<template>
  <div v-if="slides.length" class="related-content">
    <h3 class="mb-4">Related Products</h3>
    <VueSlickCarousel class="related-list" v-bind="slick.settings">
      <template #default>
        <div v-for="(slide, idx) in slides" :key="idx" class="related-item">
          <div class="related-image">
            <img :src="image(slide)" :alt="slide.title" />
          </div>
          <div class="related-title">{{ slide.name }}</div>
          <a
            v-if="slide.link"
            :href="slide.link"
            target="_blank"
            class="stretched-link"
          ></a>
          <nuxt-link
            v-else
            :to="getLink(slide.id)"
            class="stretched-link"
          ></nuxt-link>
        </div>
      </template>
      <template #nextArrow>
        <button
          class="slick-next slick-arrow"
          aria-label="Слайдер вперед"
          type="button"
        >
          <i class="icon-arrow-slider_min"></i>
        </button>
      </template>
      <template #prevArrow>
        <button
          class="slick-prev slick-arrow"
          aria-label="Слайдер назад"
          type="button"
        >
          <i class="icon-arrow-slider_min"></i>
        </button>
      </template>
    </VueSlickCarousel>
  </div>
</template>

<script>
export default {
  name: 'RelatedContent',
  props: {
    slides: {
      type: Array,
      required: false,
      default: () => [],
    },
    baseLink: {
      type: String,
      required: false,
      default: 'showroom',
    },
  },
  data() {
    return {
      slick: {
        settings: {
          speed: 300,
          slidesToShow: 6,
          slidesToScroll: 1,
          responsive: [
            {
              breakpoint: 1024,
              settings: {
                slidesToShow: 3,
              },
            },
            {
              breakpoint: 600,
              settings: {
                slidesToShow: 2,
              },
            },
            {
              breakpoint: 400,
              settings: {
                slidesToShow: 2,
              },
            },
          ],
        },
      },
    }
  },
  computed: {
    image() {
      return (slide) => {
        if (
          slide.showroom_detail_images &&
          slide.showroom_detail_images.length
        ) {
          return slide.showroom_detail_images[0].image
        }
        return slide.grid_img || slide.header_img || slide.recommend_img
      }
    },
    entityMap() {
      return this.$store.getters['sitemap/idMap'][this.baseLink]
    },
  },
  methods: {
    getLink(id) {
      return this.entityMap
        ? `/${this.baseLink}/${this.entityMap[id]}`
        : `/${this.baseLink}/`
    },
  },
}
</script>
